<?php
namespace Ep\Wp\Plugin\Core;

use Interop\Container\ContainerInterface;
use Zend\Mail\Transport\TransportInterface;
use Zend\ServiceManager\Factory\FactoryInterface;

/**
 * Stvara novu instancu Mail plugina.
 *
 * @package Ep\Wp\Plugin
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/wordpress
 */
class MailFactory implements FactoryInterface
{
    /**
     * Stvara plugin.
     *
     * @param  ContainerInterface $container
     * @param  string $requestedName
     * @param  null|array $options
     *
     * @return object
     *
     * @throws \Psr\Container\ContainerExceptionInterface
     * @throws \Psr\Container\NotFoundExceptionInterface
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        $transport = $container->get(TransportInterface::class);
        return new Mail($transport);
    }
}