<?php
namespace Ep\Wp\Plugin;

/**
 * Class Formcraft3
 *
 * @package Ep\Wp\Plugin
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-wordpress
 */
class Formcraft3 implements PluginInterface
{
    protected $oldLevel;

    /**
     * Dodaje akcije i filtere u WordPress.
     *
     * @return void
     */
    public function __invoke(): void
    {
        add_filter('do_shortcode_tag', [$this, 'do_shortcode_tag'], 10, 2);
        add_filter('pre_do_shortcode_tag', [$this, 'pre_do_shortcode_tag'], 100, 2);
    }

    /**
     * @param $false
     * @param $tag
     *
     * @return mixed
     */
    public function pre_do_shortcode_tag($false, $tag)
    {
        if ('fc' === $tag) {
            $this->oldLevel = error_reporting(0);
            $_SERVER['REQUEST_URI'] .= '?preview=true';
        }

        return $false;
    }

    /**
     * @param $output
     * @param $tag
     *
     * @return mixed
     */
    public function do_shortcode_tag($output, $tag)
    {
        if ('fc' === $tag) {
            error_reporting($this->oldLevel);
            $_SERVER['REQUEST_URI'] = preg_replace('/\?preview=true/', '', $_SERVER['REQUEST_URI']);
        }

        return $output;
    }
}