<?php
namespace Ep\Wp\Plugin;

use Zend\ServiceManager\AbstractPluginManager;
use Zend\ServiceManager\Factory\InvokableFactory;

/**
 * Omogućava stvaranje WordPress pluginova iz konfiguracije.
 *
 * @package Ep\Wp\Plugin
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-wordpress
 */
class PluginManager extends AbstractPluginManager
{
    const CONFIG_KEY = 'wp_plugins';

    /** @var string */
    protected $instanceOf = PluginInterface::class;

    /** @var array */
    protected $aliases = [
        'wp.flatsome'          => Flatsome::class,
        'wp.formcraft3'        => Formcraft3::class,
        'wp.views'             => Views::class,
        'wp.widgets'           => Widgets::class,
    ];

    /** @var array */
    protected $factories = [
        Flatsome::class         => InvokableFactory::class,
        Formcraft3::class       => InvokableFactory::class,
        Views::class            => ViewsFactory::class,
        Widgets::class          => WidgetsFactory::class,
    ];
}