<?php
namespace EpTest\Wp\Plugin;

use Ep\Wp\ConfigProvider;
use Ep\Wp\Plugin\PluginManager;
use Ep\Wp\Plugin;
use PHPUnit\Framework\TestCase;
use Zend\ServiceManager\ServiceManager;

/**
 * Class PluginManagerTest
 *
 * @package EpTest\Wp\Plugin
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-wordpress
 */
class PluginManagerTest extends TestCase
{
    /** @var PluginManager */
    private $plugins;

    protected function setUp()/* The :void return type declaration that should be here would cause a BC issue */
    {
        parent::setUp();

        $config = (new ConfigProvider())();
        $container = new ServiceManager($config['dependencies'] ?? []);
        $container->setService('config', $config);

        $this->plugins = new PluginManager($container, $config['wp_plugins'] ?? []);
    }

    public function testCanCreateTranslationCache()
    {
        $this->assertTrue($this->plugins->has('wp.i18n.translation_cache'));

        $plugin = $this->plugins->get('wp.i18n.translation_cache');

        $this->assertInstanceOf(Plugin\I18n\TranslationCache::class, $plugin);
        $this->assertSame($plugin, $this->plugins->get('wp.i18n.translation_cache'));
    }
}